var Player = {
    plugin : null,
    state : -1,
    skipState : -1,
    stopCallback : null, 
    originalSource : null,
	buffering : null,
	skipInterval : 5,
    
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4
}

Player.init = function() {
    var success = true;
    this.state = this.STOPPED;
    this.plugin = document.getElementById("pluginPlayer");
    if (!this.plugin) {
		alert('pluginPlayer fail!');
         success = false;
    }
    else {
        var mwPlugin = document.getElementById("pluginObjectTVMW");
        if (!mwPlugin) success = false;
		alert('pluginObjectTVMW fail!');
	}
	
    this.setWindow();
	
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
	this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
	
	this.plugin.OnConnectionFailed = 'Player.ConnectionFailed';
	this.plugin.OnNetworkDisconnected = 'Player.NetworkDisconnected';
	this.plugin.OnRenderError = 'Player.RenderError';
	this.plugin.OnServerError = 'Player.onServerError';

    return success;
}

Player.deinit = function() {
      alert("Player deinit !!! " );       
      
      if (this.plugin)
      {
            this.plugin.Stop();
      }
        /*var mwPlugin = document.getElementById("pluginObjectTVMW");
        
        if (mwPlugin && (this.originalSource != null) )
        {
			// If you use the srcctl by config.xml, don't need the source change in source code.
			/*
            // Restore original TV source before closing the widget 
            mwPlugin.SetSource(this.originalSource);
            alert("Restore source to " + this.originalSource);
            **/
        /*}*/
}


Player.setWindow = function() {
	
	this.plugin.SetDisplayArea(146, 80, 326, 184);
	
	if(this.state == this.PAUSED) {
		Player.pauseVideo();
	}
}

Player.setFullscreen = function() {
 
	this.plugin.SetDisplayArea(0, 0, 960, 540);
    
	if (this.state == this.PAUSED) {
		Player.pauseVideo();
	}
}
/*Player.setWindow = function() {
	_THIS_ = this;
	//setTimeout(function() { 
		var SetArea = _THIS_.plugin.SetDisplayArea(146, 80, 326, 184);
	//}, 100);
		
    if (this.state == this.PAUSED) {
		var _THIS_ = this;
		setTimeout(function() { 
			_THIS_.pauseVideo();
		}, 100);
		//this.state = this.PLAYING;
    }
}

Player.setFullscreen = function() {
    this.plugin.SetDisplayArea(0, 0, 960, 540);
    if (this.state == this.PAUSED) {
		var _THIS_ = this;
		setTimeout(function() { 
			_THIS_.pauseVideo();
		}, 100);
		//this.state = this.PLAYING;
	}
}*/

Player.setVideoURL = function(url) {
    this.url = url;
    alert("URL = " + this.url);
}

Player.playVideo = function(url) {
	alert('PLAYING');
	this.url = url;
    if (this.url == null) {
        alert("No videos to play");
    }
    else {
        this.state = this.PLAYING;
        $("#play, #playFlScr").addClass('paused');
        this.plugin.Play( this.url );
		pluginObj.setOffScreenSaver();
		this.buffering = true;
		Display.status("Buffering...");
    }
}

Player.pauseVideo = function() {
	alert('PAUSED');
    this.state = this.PAUSED;
	$("#play, #playFlScr").removeClass('paused');
    this.plugin.Pause();
}

Player.stopVideo = function(){
    if (this.state != this.STOPPED) {
		$("#play, #playFlScr").removeClass('paused');
        this.state = this.STOPPED;
        this.plugin.Stop();
		Display.status("");
		this.buffering = false;
		Display.setTime(0);
		pluginObj.setOnScreenSaver(); 
        
        if (this.stopCallback) {
            this.stopCallback();
        }
    }
    else {
        alert("Ignoring stop request, not in correct state");
    }
}

Player.resumeVideo = function() {
	alert('RESUME');
    this.state = this.PLAYING;
	$("#play, #playFlScr").addClass('paused');
    this.plugin.Resume();
}

Player.skipForwardVideo = function() {
	var timeAfterSkip = parseInt(Display.curTime) + (parseInt(this.skipInterval)*1000) + 999;
	if (timeAfterSkip > Display.totalTime) {
		this.stopVideo();
		return false;
	}
	this.skipState = this.FORWARD;
	this.plugin.JumpForward(this.skipInterval);
}

Player.skipBackwardVideo = function() {
	var timeAfterSkip = parseInt(Display.curTime) - (parseInt(this.skipInterval)*1000);
	if (timeAfterSkip <= 0) {
		this.stopVideo();
		return false;
	}
	this.skipState = this.REWIND;
	this.plugin.JumpBackward(this.skipInterval);
}

Player.getState = function() {
    return this.state;
}

// Global functions called directly by the player 
Player.onBufferingStart = function() {
    Display.status("Buffering...");
	this.buffering = true;
}

Player.onBufferingProgress = function(percent) {
    Display.status("Buffering: " + percent + "%");
}

Player.onBufferingComplete = function() {
	Display.status("");
	this.buffering = false;
}

Player.setCurTime = function(time) {
alert(time);
	if (time > Display.totalTime) {
		this.stopVideo();
		return;
	}
	Display.setTime(time);
}

Player.setTotalTime = function() {
    Display.setTotalTime(Player.plugin.GetDuration());
}

Player.NetworkDisconnected = function() {
	Player.stopVideo();
	Display.status(STR_CONTENTS_NETWORK_DISCONNECTED);
    alert("Network Disconnected!");
	SceneContents.popupShow(STR_CONTENTS_NETWORK_DISCONNECTED, STR_CONTENTS_BUTTON_OK);
}

Player.ConnectionFailed = function() {
	Player.stopVideo();
	Display.status(STR_CONTENTS_CONNECTION_FAILED);
    alert("Connection Failed!");
	SceneContents.popupShow(STR_CONTENTS_CONNECTION_FAILED, STR_CONTENTS_BUTTON_OK);
}

Player.onServerError = function() {
	Player.stopVideo();
	alert("Server Error");
	Display.status(STR_CONTENTS_SERVER_ERROR);
	SceneContents.popupShow(STR_CONTENTS_SERVER_ERROR, STR_CONTENTS_BUTTON_OK);
}

Player.RenderError = function() {
	Player.stopVideo();
	Display.status(STR_CONTENTS_RENDER_ERROR);
	alert("Render Error");
	SceneContents.popupShow(STR_CONTENTS_RENDER_ERROR, STR_CONTENTS_BUTTON_OK);
}


getBandwidth = function(bandwidth) { alert("getBandwidth " + bandwidth); }

onDecoderReady = function() { alert("onDecoderReady"); }

stopPlayer = function() {
    Player.stopVideo();
}

setTottalBuffer = function(buffer) { alert("setTottalBuffer " + buffer); }

setCurBuffer = function(buffer) { alert("setCurBuffer " + buffer); }
