function SceneContents() {
    this.articleTitle = null;
    this.articleDescription = null;
    this.contentsIdx;
    this.arrArticles = [];
	this.arrArticlesLength = null;
	this.playList = [];
	this.currFilm = null;
	
    this.selectedVideo = 0;
    this.mode = 0;
    this.mute = 0;
    this.UP = 0;
    this.DOWN = 1;
    this.WINDOW = 0;
    this.FULLSCREEN = 1;
    this.NMUTE = 0;
    this.YMUTE = 1;
	
	this.kHlpHideTimer = 0;
	this.kHlpHideTimerMax = 5;
	this.kHlpHideTimerValue = 0;
	
	this.contentsIdxGrouped = -1;
	
	this.buttons = [];
	this.buttonIdx = 1;
	
	this.contKeyHelp = $("#keyhelpContents");
	this.videoBoxFScreen = $("#videoBoxFScreen");
	
	this.totalPage = 0;
	this.scrollBar = null;
	this.scrollBead = null;
	this.scrollBarSize = 260;
	
	this.title_max_num = 9;
}

SceneContents.prototype.initialize = function () {
    this.articleTitle = document.getElementById("ContentsTitle");
    this.articleDescription = document.getElementById("ContentsDescription");
}

SceneContents.prototype.handleShow = function (data) {
if($(data).length > 0) {
	this.contentsIdx = data.index;
	this.currFilm = this.contentsIdx;
    this.arrArticles = data.array;
	this.arrArticlesLength = this.arrArticles.length;
	
	// set play button default
	this.buttonIdx = 1;
	this.buttons = ['#rewind', '#play', '#forward', '#stop'];
	
	// if current element (film) has no video url, save its index for 'return' event
	if (data.grouped == true) {
		this.contentsIdxGrouped = this.contentsIdx;
		this.contentsIdx = 0;
		this.currFilm = 0;
	}
	
	// set title & description 
	this.showContents(this.contentsIdx);
	
	// set player back picture
	this.playerBackShow();

	// set buffering state to false
	Player.buffering = false;

	// initialize current play list   
	var items = [],
		obj = {}
		pict = [];
	
	this.playList = [];
	for(var i = 0; i < this.arrArticlesLength; i++) {
		obj = {
			url: this.arrArticles[i].video,
			title: this.arrArticles[i].title,
			image: this.arrArticles[i].image
		}
		//pict.push(this.arrArticles[i].image);
		this.playList.push(obj);
		if (data.grouped == true) {
			items.push(this.arrArticles[i].title_a);
		}
		else {
			items.push(this.arrArticles[i].title);
		}
	}
	
	//preload pictures from list
	//Controller.preloadImages(pict);

	// put buttons in player bottom frame
	for(var i in this.buttons) {
		$(this.buttons[i]).sfButton();
		if (i == this.buttonIdx) $(this.buttons[i]).sfButton('focus');
	}

	// set the list of related videos
	if (items.length > 1) {
		// if list not NULL, create sfList
		var lstVideoPlayer = $('<div>', {
			id: 'lstVideoPlayer',
		});
		$("#SceneContents").append(lstVideoPlayer);
		$("#lstVideoPlayer").sfList({
			data: items,
			index: this.contentsIdx,
			itemsPerPage: this.title_max_num
		});
		this.buttons.push('#lstVideoPlayer');
		
		this.totalPage = Math.ceil(this.arrArticlesLength / this.title_max_num);
	}
	else {
		this.totalPage = 0;
	}

}
	this.scrollBar = document.getElementById("ContentsScrollBar");
	this.scrollBead = document.getElementById("ContentsScrollBead");
	this.adjustScrollBar();

    if ( Player.init() && Display.init()) {
		
		var _THIS_ = this;
		
        Player.stopCallback = function() {
            /* Return to windowed mode when video is stopped (by choice or when it reaches the end) */
            if (_THIS_.mode == _THIS_.FULLSCREEN) {
				_THIS_.setWindowMode();
			}
			_THIS_.setKeyHelp();
			_THIS_.playerBackShow();
        }
        widgetAPI.sendReadyEvent();
    }
    else {
        alert("!!!Failed to initialise!!!");
		if (!Player.init()) { alert('Player failed'); }
		if (!Display.init()) { alert('Display failed'); }
    }
	
	// set buttom keyHelp
	this.setKeyHelp();
}	

SceneContents.prototype.playerBackShow = function () {
	// set back picture for player
	var playerBack = document.getElementById('videoPlayer');
	playerBack.style.backgroundImage = "url('" + this.arrArticles[this.contentsIdx].image + "')";
}

SceneContents.prototype.playerBackHide = function () {
	// hide back picture for player
	var playerBack = document.getElementById('videoPlayer');
	playerBack.style.backgroundImage = "none";
}

SceneContents.prototype.handleHide = function () {
	alert("SceneContents.handleHide()");
	// i can't handle with .sfList('clear'), so i remove sfList element from DOM on scene hiding
	//$("#lstVideoPlayer").remove();
	$("#lstVideoPlayer").detach();
	Display.status("");
	this.hideKeyHelp();
}

SceneContents.prototype.handleFocus = function () {
	alert("SceneContents.handleFocus()");
}

SceneContents.prototype.handleBlur = function () {
	alert("SceneContents.handleBlur()");
}

SceneContents.prototype.showContents = function (index) {
	alert("SceneContents.showContents()");
	var title = (this.arrArticles[index].title)? this.arrArticles[index].title : '',
		desc = (this.arrArticles[index].description)? this.arrArticles[index].description : '',
		date = (this.arrArticles[index].date)? this.arrArticles[index].date : '',
		title_a = (this.arrArticles[index].title_a)? this.arrArticles[index].title_a : '';
	
	desc = desc.replace(/<br[^>]*>/gi, "");
	
	i = desc.length;
	if(i > 295) {
		//desc = desc.substring(0,295) +'&#133;';

		desc = desc.replace(/\.\.\./g, '&#133;');
		desc = desc.replace(/&#133;$/g, '');

		desc = desc.substring(0,295);
		var separator = ['?', '!', ',', '.'];
			
		do{
			i--;
		}
		while(jQuery.inArray(desc[i], separator) == -1 && i >= 0);
		desc = desc.substring(0, i) + '&#133;';
	}

	this.articleTitle.innerHTML = title.replace(/<br[^>]*>/gi, "");
	this.articleDescription.innerHTML = desc + '<span>' + date.replace(/<br[^>]*>/gi, "") + ' ' + title_a.replace(/<br[^>]*>/gi, "") + '</span>';
	Display.clearTime();
} 

SceneContents.prototype.handleKeyDown = function() {

    var keyCode = event.keyCode; 
    alert("Key pressed: " + keyCode);
	switch(keyCode) {
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            alert("RETURN");
			if (this.mode != this.FULLSCREEN) {
				//exit to main scene if not in fullscreen mode
				if(Player.getState() != Player.STOPPED) Player.stopVideo();
				sf.scene.hide('Contents');
				if (this.contentsIdxGrouped != -1) {
					Controller.showMain(this.contentsIdxGrouped);
					this.contentsIdxGrouped = -1;
				}
				else {
					Controller.showMain(this.contentsIdx);
				}
			}
			else {
				//exit to window if in fullscreen mode
				this.setWindowMode();
				this.setKeyHelp();	
			}
			widgetAPI.blockNavigation(event);
            break;    
        case tvKey.KEY_PLAY:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("PLAY");
			if (Player.buffering == false) {
				this.handlePlayKey();
			}
            break;
        case tvKey.KEY_STOP:
            alert("STOP");
            if (Player.buffering == false) {
				Player.stopVideo();
				this.setKeyHelp();
			}
            break;
        case tvKey.KEY_PAUSE:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("PAUSE");
			if (Player.buffering == false) {
				this.handlePauseKey();
			}
            break;
        case tvKey.KEY_FF:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("FF");
			if (Player.buffering == false) {
                Player.skipForwardVideo();
			}
            break;
        case tvKey.KEY_RW:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("RW");
			if (Player.buffering == false) {
                Player.skipBackwardVideo();
			}
            break;
		case tvKey.KEY_LEFT:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
			alert("KEY_LEFT");
			if (this.mode != this.FULLSCREEN && Player.buffering == false) {
				this.buttonsFocusLeft();
			}
			break;
		case tvKey.KEY_RIGHT:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
			alert("KEY_RIGHT");
			if (this.mode != this.FULLSCREEN && Player.buffering == false) {
				this.buttonsFocusRight();
			}
			break;
        case tvKey.KEY_DOWN:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("DOWN");
			if (this.mode != this.FULLSCREEN && this.buttons[this.buttonIdx] == '#lstVideoPlayer' && Player.buffering == false) {
				$("#lstVideoPlayer").sfList('next');
				if (this.currFilm == this.arrArticlesLength - 1) {
					this.currFilm = 0;
				}
				else {
					this.currFilm++;
				}
				this.adjustScrollBar();
			}
            break;
        case tvKey.KEY_UP:
			if (this.mode == this.FULLSCREEN) this.showKeyHelp();
            alert("UP");
			if (this.mode != this.FULLSCREEN && this.buttons[this.buttonIdx] == '#lstVideoPlayer' && Player.buffering == false) {
				$("#lstVideoPlayer").sfList('prev');
				if (this.currFilm == 0) {
					this.currFilm = this.arrArticlesLength - 1;
				}
				else {
					this.currFilm--;
				}
				this.adjustScrollBar();
			}
            break;
        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
			alert("KEY_ENTER");
			if (this.mode != this.FULLSCREEN && Player.buffering == false) {
				if (this.buttons[this.buttonIdx] == '#lstVideoPlayer') {
					if (this.currFilm != this.contentsIdx) {
						if (Player.getState() != Player.STOPPED){
							Player.stopVideo();
							this.setKeyHelp();
						}
						this.showContents(this.currFilm);
						this.contentsIdx = this.currFilm;
						this.playerBackShow();
					}
				}
				else if(this.buttons[this.buttonIdx] == '#rewind') {
					Player.skipBackwardVideo();                
				}
				else if(this.buttons[this.buttonIdx] == '#forward') {
					Player.skipForwardVideo();
				}
				else if(this.buttons[this.buttonIdx] == '#play') {
					if (Player.getState() == Player.PLAYING) {
						this.handlePauseKey();
					}
					else {
						this.handlePlayKey();
					}
				}
				else if(this.buttons[this.buttonIdx] == '#stop') {
					Player.stopVideo();
					this.setKeyHelp();
				}
			}
            break;
		case tvKey.KEY_GREEN:
			alert("GREEN");
			if (Player.buffering == false) {
				this.toggleMode();
			}
            break;
        default:
            alert("Unhandled key");
            break;
    }
}

SceneContents.prototype.adjustScrollBar = function () {
    alert("SceneContents.adjustScrollBar()");
    if(this.totalPage <= 1) {
           this.hideScrollBar();
    }
    else {
           var curPage = parseInt(this.currFilm / this.title_max_num),
				position = Math.round((curPage*this.scrollBarSize)/(this.totalPage-1));
           this.scrollBead.style.top = position + "px";
           this.showScrollBar();
    }
}

SceneContents.prototype.showScrollBar = function () {
    alert("SceneContents.showScrollBar()");
    this.scrollBar.style.display = "block";
}

SceneContents.prototype.hideScrollBar = function () {
    alert("SceneContents.hideScrollBar()");
    this.scrollBar.style.display = "none";
}

SceneContents.prototype.buttonsFocusRight = function() {
	if (this.buttons[this.buttonIdx] != '#lstVideoPlayer' && this.buttons[this.buttonIdx] != '#stop' && this.buttonIdx < this.buttons.length-1) {
		$(this.buttons[this.buttonIdx]).sfButton('blur');
		this.buttonIdx++;
		$(this.buttons[this.buttonIdx]).sfButton('focus');
	}
	else if (this.buttons[this.buttonIdx] == '#stop' && this.buttonIdx < this.buttons.length-1) {
		$(this.buttons[this.buttonIdx]).sfButton('blur');
		this.buttonIdx = this.buttons.length-1;
		$(this.buttons[this.buttonIdx]).sfList('focus');
	}
	else if(this.buttons[this.buttonIdx] == '#stop' && this.buttonIdx == this.buttons.length-1) {
		$(this.buttons[this.buttonIdx]).sfButton('blur');
		this.buttonIdx = 0;
		$(this.buttons[this.buttonIdx]).sfButton('focus');
	}
	else if (this.buttons[this.buttonIdx] == '#lstVideoPlayer') {
		$(this.buttons[this.buttonIdx]).sfList('blur');
		this.buttonIdx = 0;
		$(this.buttons[this.buttonIdx]).sfButton('focus');
	}
}

SceneContents.prototype.buttonsFocusLeft = function() {
	if (this.buttonIdx > 0 && this.buttons[this.buttonIdx] != '#lstVideoPlayer') {
		$(this.buttons[this.buttonIdx]).sfButton('blur');
		this.buttonIdx--;
		$(this.buttons[this.buttonIdx]).sfButton('focus');
	}
	else if (this.buttonIdx == 0) {
		$(this.buttons[this.buttonIdx]).sfButton('blur');
		this.buttonIdx = this.buttons.length-1;
		if (this.buttons[this.buttonIdx] == '#lstVideoPlayer') {
			$(this.buttons[this.buttonIdx]).sfList('focus');
		}
		else {
			$(this.buttons[this.buttonIdx]).sfButton('focus');
		}
	}
	else if (this.buttons[this.buttonIdx] == '#lstVideoPlayer') {
		$(this.buttons[this.buttonIdx]).sfList('blur');
		this.buttonIdx--;
		$(this.buttons[this.buttonIdx]).sfButton('focus');
	}
}

SceneContents.prototype.handlePlayKey = function() {
	var item = this.playList[this.contentsIdx];
	if (item.url !== undefined) {
		item.fullScreen = false;
		switch (Player.getState()) {
			case Player.STOPPED:
				
				// HACK!
				setTimeout(function() {
					Player.setWindow();
				}, 100);
				
				
				this.playerBackHide();
				Player.playVideo(item.url);
				this.setKeyHelp();
				break;
			case Player.PAUSED:
				Player.resumeVideo();
				break;
			default:
				alert("Ignoring play key, not in correct state");
				break;
		}
	}
	else {
		SceneContents.popupShow(STR_CONTENTS_VIDEO_URL_NOT_FND, STR_CONTENTS_BUTTON_OK);
		alert('Error: video URL not found');
	}
}

SceneContents.popupShow = function(text, button) {
	$('#popupContents').sfPopup({
		text: text,
		buttons: button
	}); 
	$('#popupContents').sfPopup('show'); 
}

SceneContents.prototype.handlePauseKey = function() {
    switch (Player.getState()) {
        case Player.PLAYING:
            Player.pauseVideo();
            break;
        default:
            alert("Ignoring pause key, not in correct state");
            break;
    }
}

SceneContents.prototype.setWindowMode = function() {
	if (this.mode != this.WINDOW){
		Player.setWindow();
		Display.show();
		this.mode = this.WINDOW;
		this.hideKeyHelp();
    }
}

SceneContents.prototype.setFullScreenMode = function() {
    if (this.mode != this.FULLSCREEN && Player.getState() != Player.STOPPED) {
        Player.setFullscreen();
		Display.hide();
        this.mode = this.FULLSCREEN;
		this.showKeyHelp();
    }
}

SceneContents.prototype.toggleMode = function() {
    switch (this.mode) {
        case this.WINDOW:
            this.setFullScreenMode();
			this.setKeyHelp();
            break;
        case this.FULLSCREEN:
            this.setWindowMode();
			this.setKeyHelp();
            break;
        default:
            alert("ERROR: unexpected mode in toggleMode");
            break;
    }
}

SceneContents.prototype.showKeyHelp = function() {
	if ($(this.contKeyHelp).is(':hidden')) {
		$(this.contKeyHelp).show();
	}
	if ($(this.videoBoxFScreen).is(':hidden')) {
		$(this.videoBoxFScreen).show();
	}
	
	clearInterval(this.kHlpHideTimer);
	this.kHlpHideTimerValue = 0;
		
	var _THIS_ = this;
		
	this.kHlpHideTimer = setInterval( function() {
		setHKeyTimer();
	}, 1000);
	
	function setHKeyTimer() {
		if (_THIS_.kHlpHideTimerValue < _THIS_.kHlpHideTimerMax) {
			_THIS_.kHlpHideTimerValue++;
			alert('Timer: changed, SceneContents.kHlpHideTimerValue = ' + _THIS_.kHlpHideTimerValue);
		}
		else {
			_THIS_.hideKeyHelp();
		}
	}	
}

SceneContents.prototype.hideKeyHelp = function() {
	$(this.contKeyHelp).hide();
	$(this.videoBoxFScreen).hide();
	
	clearInterval(this.kHlpHideTimer);
	this.kHlpHideTimerValue = 0;
}

SceneContents.prototype.setKeyHelp = function () {
	var oKeyMap = {};
	
	if(Player.state != Player.STOPPED) {
		if (this.mode != this.FULLSCREEN) {
			oKeyMap.GREEN = STR_CONTENTS_FULLSCREEN + '&nbsp;&nbsp;&nbsp;';
		}
		else {
			oKeyMap.GREEN = STR_CONTENTS_WINDOW + '&nbsp;&nbsp;&nbsp;';
		}
	}
	
	oKeyMap.REW = '';
	oKeyMap.PLAY = '';
	oKeyMap.PAUSE = '';
	oKeyMap.FF = '';
	oKeyMap.STOP = STR_CONTENTS_VCONTROL + '&nbsp;&nbsp;';

	if (this.mode != this.FULLSCREEN) {
		oKeyMap.UPDOWN = STR_CONTENTS_UPDOWN + '&nbsp;&nbsp;';
		oKeyMap.ENTER = STR_CONTENTS_ENTER + '&nbsp;&nbsp;';
	}
	oKeyMap.RETURN = STR_CONTENTS_RETURN;
	
	
	if ($(this.contKeyHelp).is(':hidden')) {
		$(this.contKeyHelp).show();
	}
	$(this.contKeyHelp).sfKeyHelp(oKeyMap);
}
