var widgetAPI = new Common.API.Widget(),
	tvKey = new Common.API.TVKeyValue(),
	pluginObj = new Common.API.Plugin();
	
function SceneMain() {
	this.titleIdx = 0;
	this.articleIdx = 0;
	this.arrTitles = new Array();
	this.title_max_num = 4;
	this.categoryList = null;
	this.categoryIdx = 0;
	this.categoryFlag = new Boolean(true);

    this.totalPage = 0;
    this.scrollBar = null;
    this.scrollBead = null;
    this.scrollBarSize = 360;
}

SceneMain.prototype.highlightTitle = function (index) {
	$(this.arrTitles[index]).addClass("highlight");
}

SceneMain.prototype.blurTitle = function (index) {
	$(this.arrTitles[index]).removeClass("highlight");
} 

SceneMain.prototype.initialize = function () {
    this.categoryList = document.getElementById("MainCategoryList");
    $('#MainCategoryList').sfList({
           data:[Controller.categoryData[0].name,Controller.categoryData[1].name,Controller.categoryData[2].name,Controller.categoryData[3].name,Controller.categoryData[4].name],
           itemsPerPage:5,
    });
    $('#MainCategoryList').sfList('focus');
}

SceneMain.prototype.handleShow = function (data) {
	alert("SceneMain.handleShow()");
	if($(data).length > 0) {
		this.blurTitle(this.titleIdx);
		this.articleIdx = data.Index;
		this.titleIdx = this.articleIdx%this.title_max_num;
		this.showTitleList(this.articleIdx - this.titleIdx);
		this.highlightTitle(this.titleIdx);
		this.adjustScrollBar(this.articleIdx, this.arrArticles.length);
	}
}

SceneMain.popupShow = function(text, button) {
	$('#popupMain').sfPopup({
		text: text,
		buttons: button
	}); 
	$('#popupMain').sfPopup('show'); 
}

SceneMain.prototype.handleHide = function () {
	alert("SceneMain.handleHide()");
}

SceneMain.prototype.handleFocus = function () {
	alert("SceneMain.handleFocus()");
	this.setKeyHelp();
}

SceneMain.prototype.handleBlur = function () {
	alert("SceneMain.handleBlur()");
}

SceneMain.prototype.handleKeyDown = function (keyCode) {
	alert("SceneMain.handleKeyDown(" + keyCode + ")");
	switch (keyCode) {
		case sf.key.RETURN:
			widgetAPI.sendReturnEvent(); 
			break;
		case sf.key.LEFT:
			if(this.categoryFlag == false) {
				this.categoryFlag = true;
				$('#MainCategoryList').sfList('focus');
				this.blurTitle(this.titleIdx);
			}
			break;
		case sf.key.RIGHT:
			if(this.categoryFlag == true && this.categoryIdx != 4) {
				this.categoryFlag = false;
				$('#MainCategoryList').sfList('blur');
				this.highlightTitle(this.titleIdx);
			}
			break;
		case sf.key.UP:
			if(this.categoryFlag == false) {
				this.upArticle();
			}
			else {
				this.categoryIdx--;
				if(this.categoryIdx < 0) {
					$('#MainCategoryList').sfList('move', 4);
					this.categoryIdx = 4;
				}
				else {
					$('#MainCategoryList').sfList('prev');
				}
				this.refreshCategory();
			}
			break;
		case sf.key.DOWN:
			if(this.categoryFlag == false) {
				this.downArticle();
			}
			else {
				this.categoryIdx++;
				if(this.categoryIdx > 4) {
					$('#MainCategoryList').sfList('move', 0);
					this.categoryIdx = 0;
				}
				else {
					$('#MainCategoryList').sfList('next');
				}
				this.refreshCategory();
			}
			break;
		case sf.key.ENTER:
			if(this.categoryFlag == false) {
				if (this.arrArticles[this.articleIdx].video == undefined) {
					Controller.GetJSON('http://lgtv.1internet.tv/json/' + Controller.categoryData[this.categoryIdx].group + '_' + this.arrArticles[this.articleIdx].id + '.json', true, this.articleIdx);
				}
				else {
					sf.scene.hide('Main');
					Controller.showContents(this.articleIdx);
				}
			}
			else {
				if (this.categoryIdx != 4) {
					this.categoryFlag = false;
					$('#MainCategoryList').sfList('blur');
					this.highlightTitle(this.titleIdx);
				}
			}
			break;
		default:
			alert('Unhandled key down, key code: ' + keyCode);
		break;
	}
}

SceneMain.prototype.upArticle = function () {
	this.blurTitle(this.titleIdx);
	this.articleIdx--;
	this.titleIdx--;

	if(this.titleIdx < 0) {
		this.titleIdx = this.title_max_num - 1;
		if(this.articleIdx < 0) {
			this.articleIdx = this.arrArticles.length - 1;
			this.titleIdx = this.articleIdx % this.title_max_num;
		}
		this.adjustScrollBar(this.articleIdx, this.arrArticles.length);
		this.showTitleList(this.articleIdx - this.titleIdx);
		
	}
	this.highlightTitle(this.titleIdx);
}

SceneMain.prototype.downArticle = function () {
	this.blurTitle(this.titleIdx);
	this.articleIdx++;
	this.titleIdx++;
	if(this.articleIdx % this.title_max_num == 0 || this.articleIdx > this.arrArticles.length - 1) {
		this.titleIdx = 0;
		if(this.articleIdx > this.arrArticles.length - 1) this.articleIdx = 0;
        this.adjustScrollBar(this.articleIdx, this.arrArticles.length);
		this.showTitleList(this.articleIdx);
	}
	this.highlightTitle(this.titleIdx);
}

SceneMain.prototype.initMainpage = function (Array) {
	if ($(Array).length > 0) {
		this.arrArticles = Array;
		//this.totalPage = ((this.arrArticles.length - 1) / this.title_max_num) + 1;
		this.totalPage = Math.ceil(this.arrArticles.length / this.title_max_num);
		this.scrollBar = document.getElementById("MainScrollBar");
		this.scrollBead = document.getElementById("MainScrollBead");
		this.adjustScrollBar(this.articleIdx, this.arrArticles.length);
		this.showMainpage(this.articleIdx);
	}
} 

SceneMain.prototype.showMainpage = function (articleIndex) {
	var UIListTitles = document.getElementById("MainListTitles");		
	this.showTitleList(articleIndex);
}

SceneMain.prototype.showTitleList = function (index) { 
	var UIListTitles = document.getElementById("MainListTitles");

	for (var i=0; i < this.title_max_num; i++) {
		this.arrTitles[i] = document.getElementById("MainListTitle"+i);
	}

	var article = null;
	for(var a = 0; a < this.title_max_num; a++) {
		article = this.arrArticles[index + a];
		if (article) {
			var tumb =  article.image.replace(/imgsize(\d+x\d+)/,"imgsize120x90");
			this.arrTitles[a].innerHTML = this.wrapInTable("<img src='" + tumb + "'/>" + article.title + "<span>" + article.date + " " + article.title_a + '</span', "article.title", "MainListTitle_style");
		}
		else {
			this.arrTitles[a].innerHTML = "";
		}
	}
}

SceneMain.prototype.showPreview = function (index) {
	var previewTitle = document.getElementById("MainPreviewTitle");
	var previewDescription = document.getElementById("MainPreviewDescription");
	previewTitle.innerHTML = this.wrapInTable(this.arrArticles[index].title, "", "MainPreviewTitletitle_style");
	previewDescription.innerHTML = this.arrArticles[index].description.replace(/<img [^>]+>/g, "").replace(/<br[^>]*>/gi, "");
}

SceneMain.prototype.wrapInTable = function (pStrContents, pStyle, pClass) {
	var retValue = "", strStyle = "", strClass = "";
	if (pStyle)	strStyle = " style='" + pStyle + "' ";
	if (pClass) strClass = " class='" + pClass + "' ";

	retValue += "<table cellpadding='0px' cellspacing='0px'>";
	retValue += "<tr>";
	retValue += "<td" + strStyle + strClass + ">";
	retValue += pStrContents;
	retValue += "</td>";
	retValue += "</tr>";
	retValue += "</table>";

	alert("Util.wrapInTable() returns [" + retValue + "]");
	return retValue;
}

SceneMain.prototype.refreshCategory = function () {
	var staticHTML = $('#StaticHTML'),
		listTitles = $('#MainListTitles div');
	
	if (this.categoryIdx == 4) {
		//if contacts page
		listTitles.html('');
		this.hideScrollBar();
		staticHTML.html(menu[4].html);
	}
	else {
		if (staticHTML.html() != '') {
			staticHTML.html('');
		}
		this.blurTitle(this.titleIdx);
		this.titleIdx = 0;
		this.articleIdx = 0;
		delete this.arrArticles;
		Controller.start(Controller.categoryData[this.categoryIdx]);
	}
}

SceneMain.prototype.adjustScrollBar = function (artIndex, totlaArticle) {
    alert("SceneMain.adjustScrollBar()");
    var curPage = parseInt(this.articleIdx / this.title_max_num);
	alert('!!!!!!!!!!!!!!!!!!!!!curPage='+curPage+', this.totalPage='+this.totalPage+'!!!!!!!!!!!!!!!!!!!!!!'); 
    if(this.totalPage <= 1) {
           this.hideScrollBar();
    }
    else {
           var position = Math.round((curPage*this.scrollBarSize)/(this.totalPage-1));
           this.scrollBead.style.top = position + "px";
           this.showScrollBar();
    }
}

SceneMain.prototype.showScrollBar = function () {
    alert("SceneMain.showScrollBar()");
    this.scrollBar.style.display = "block";
}

SceneMain.prototype.hideScrollBar = function () {
    alert("SceneMain.hideScrollBar()");
    this.scrollBar.style.display = "none";
}


SceneMain.prototype.setKeyHelp = function () {
	var oKeyMap = {};
	oKeyMap.LEFTRIGHT = STR_MAIN_LEFTRIGHT + '&nbsp;&nbsp;';
	oKeyMap.UPDOWN = STR_CONTENTS_UPDOWN + '&nbsp;&nbsp;';
	oKeyMap.ENTER = STR_CONTENTS_ENTER + '&nbsp;&nbsp;';
	oKeyMap.RETURN = STR_MAIN_RETURN;
	$("#keyhelpMain").sfKeyHelp(oKeyMap);
}
